/*    pong is free software: you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation, either version 3 of the License, or
      (at your option) any later version.

      pong is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.

      You should have received a copy of the GNU General Public License
      along with pong.  If not, see <http://www.gnu.org/licenses/>.

*/

class ball
{

public:
	ball(int radius, int x, int y, short speed)
	{
		_ball.setRadius(radius);
		_ball.setPosition(x,y);
		this->original_speed=speed;
		this->speed=speed;
	}

	int getX()
	{
		return _ball.getPosition().x;
	}


	int getY()
	{
		return _ball.getPosition().y;
	}

	void move()
	{
		_ball.setPosition(_ball.getPosition().x+this->speed*0.07,_ball.getPosition().y+this->angle*0.07);
	}

	sf::FloatRect getGlobalBounds()
	{
		return _ball.getGlobalBounds();
	}

	void bounce()
	{
		double ex=(double)rand() / RAND_MAX;
		this->angle=0.01+ex*(2.00-00.1);
		if(rand()%10 < 5) this->angle=-this->angle;
		this->original_speed=-this->original_speed;
		if(this->speed > 0 && this->bounce_speed > 0) _ball.setPosition(_ball.getPosition().x-18,_ball.getPosition().y);
		if(this->speed < 0 && this-> bounce_speed < 0) _ball.setPosition(_ball.getPosition().x+18,_ball.getPosition().y);
		this->bounce_speed=-this->bounce_speed;
		this->speed=this->original_speed;



	}

	void setPosition(int x,int y)
	{
		_ball.setPosition(x,y);
	}

	void wall_bounce()
	{
		this->angle=-this->angle;
		this->speed=this->speed+this->bounce_speed;

	}

	void resetAngle()
	{
		this->angle=0;
	}

	void resetSpeed()
	{
		this->speed=-this->original_speed;
	}

	void draw(sf::RenderWindow &window)
	{
		window.draw(_ball);
	}
private:
	short original_speed;
	short speed=0;
	short bounce_speed=2;
	double angle=0.00;
	sf::CircleShape _ball;
};
