/*    pong is free software: you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation, either version 3 of the License, or
      (at your option) any later version.

      pong is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.

      You should have received a copy of the GNU General Public License
      along with pong.  If not, see <http://www.gnu.org/licenses/>.

*/

class simpleRect
{
public:
	simpleRect(int w,int h,int x, int y)
	{
		_simpleRect.setSize(sf::Vector2f(w,h));
		_simpleRect.setPosition(x,y);
		_simpleRect.setFillColor(sf::Color::White);
	}

	int getX()
	{
		return _simpleRect.getPosition().x;
	}

	int getY()
	{
		return _simpleRect.getPosition().y;
	}

	void draw(sf::RenderWindow &window)
	{
		window.draw(_simpleRect);
	}

private:
	sf::RectangleShape _simpleRect;
};
